// LICENSE:  LGPL2.1
// Copyright (c) 2002 Tomoya Tokairin

#include "oggdecdll.h"
#include "malloc.h" // for _aligned_malloc



// fobOp
#ifdef _DEBUG
	FILE *f;
#endif


//--------------------------------------------------
// init
BOOL EXPORT WINAPI oggdec_init(){

	DWORD i;

	if(Buffer) GlobalFree(Buffer);
	Buffer =(LPBYTE)GlobalAlloc(GPTR,sizeof(BYTE)*BUFSIZE);
	memset(Buffer,0,BUFSIZE);

	if(PCMbuffer) GlobalFree(PCMbuffer);
	PCMbuffer =(short*)GlobalAlloc(GPTR,sizeof(short)*MAXPCMBUFSIZE);

	for(i=0;i<2;i++){
		if(FtPCMbufer[i]) _aligned_free(FtPCMbufer[i]);
		FtPCMbufer[i] =(float*)_aligned_malloc(sizeof(float)*MAXPCMSAMPLESIZE,16);
	}

	if(FtVol) _aligned_free (FtVol);
	FtVol =(float*)_aligned_malloc(sizeof(float)*16,16);
	FtVol[0] = FtVol[1] = FtVol[2] = FtVol[3] = 32767.;

	if(GetWaveBuffer) GlobalFree(GetWaveBuffer);
	GetWaveBuffer =(short*)GlobalAlloc(GPTR,sizeof(short)*MAXPCMBUFSIZE); 

	GetCpuInfo(&dwSSE,&dwSSE2,&dwMMX);

	HsempLock = CreateSemaphore(NULL,1,1,NULL);

#ifdef _DEBUG
	f = fopen("test.txt","w");
#endif

	return TRUE;
}



//------------------------------------
// stop
BOOL EXPORT oggdec_stop(){
	
	DWORD i;
	BOOL bRet = TRUE;

	if(!HdOggPlayThread) return TRUE;

	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;
	
	DwThreadStat = ID_THREAD_OFF;

	// XbhƂ܂܂ő҂
	i=0;
	while(HdOggPlayThread && i<50){
		Sleep(50);
		i++;
	}
	if(i >= 50) bRet =  FALSE;
	else {
		DblSeekTime = 0; // 擪Ɋ߂
		BlPause = FALSE;
	}

	ReleaseSemaphore(HsempLock,1,NULL);

	return bRet;
}



//--------------------------------------------------
// close
BOOL EXPORT oggdec_close(){

	if(!oggdec_stop()) return FALSE;

	if(HdInputOggFile) CloseHandle(HdInputOggFile);
	HdInputOggFile = NULL;

	ogg_stream_clear(&o_stream);
	vorbis_block_clear(&v_block);
	vorbis_dsp_clear(&v_dsp);
	vorbis_comment_clear(&v_comment);
	vorbis_info_clear(&v_info);  
	ogg_sync_clear(&o_sync);

	return TRUE;
}





//--------------------------------------------------
// free
BOOL EXPORT oggdec_free(){

	DWORD i;

	if(!oggdec_close()) return FALSE;

	if(Buffer) GlobalFree(Buffer); Buffer = NULL;
	for(i=0;i<2;i++) if(FtPCMbufer[i]) _aligned_free(FtPCMbufer[i]);
	if(PCMbuffer) GlobalFree(PCMbuffer); PCMbuffer = NULL;
	if(FtVol) _aligned_free (FtVol); FtVol = NULL;
	if(GetWaveBuffer) GlobalFree(GetWaveBuffer); GetWaveBuffer = NULL;

	CloseHandle(HsempLock);

#ifdef _DEBUG	
	fclose(f);
#endif

	return TRUE;
}



//--------------------------------------------------
// open
BOOL EXPORT oggdec_open(LPCSTR lpszFileName, LPOGGINPUTINFO pInfo){

	DWORD dwByte,i,dwReadByte;
	char** ppszComment;

	if(HdOggPlayThread) return FALSE; // now, playing file

	HdInputOggFile = CreateFile(lpszFileName,GENERIC_READ,0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL); 
	if(HdInputOggFile == INVALID_HANDLE_VALUE) goto L_ERR;

	DwFileSize = GetFileSize(HdInputOggFile,NULL);
	dwReadByte = min(DwFileSize,BUFSIZE);


#ifdef _DEBUG
	fprintf(f,"file size = %d\n",DwFileSize);
#endif	

	// seach for "Oggs" , ignore whether this is 'RIFF' file or not.
	SetFilePointer(HdInputOggFile,0,NULL,FILE_BEGIN);
	ReadFile(HdInputOggFile,Buffer,dwReadByte, &dwByte, NULL);
	if(dwByte <= 4) goto L_ERR;
	for(i=0;i<dwByte-4;i++){
		if(((*(LPDWORD)(Buffer+i)) ^ OGG_HEAD_DWORD) == 0){

#ifdef _DEBUG
	fprintf(f,"[%d] %c%c%c%c %d\n",i,Buffer[i],Buffer[i+1],Buffer[i+2],Buffer[i+3],*(LPDWORD)(Buffer+i));
#endif

			// check if this is first page
			if(Buffer[i+5] & 0x02){ 
				SetFilePointer(HdInputOggFile,i,NULL,FILE_BEGIN);
				break;
			}
		}
	}

#ifdef _DEBUG
	fprintf(f,"offset = %d\n",i);
#endif
	
	if(i==dwByte-4) goto L_ERR; // could not find "Oggs" 

	// obt@
	ogg_sync_init(&o_sync); 
	
	//----------------------------------------
	// ŏ̃y[W ogg `ǂ̊mF
	//-----------------------------------------

	// hdd -> sync
	dwByte = WriteToSyncBuf(HdInputOggFile,&o_sync,
		4*1024 //  4k ʂ OK
		);
	if(dwByte < 4*1024) goto L_ERR;
	
	// sync -> page
	if(ogg_sync_pageout(&o_sync,&o_page) == 0) goto L_ERR;

	// VAǂŃXg[̏
	LnSerial = ogg_page_serialno(&o_page); 
	ogg_stream_init(&o_stream,LnSerial);
	vorbis_info_init(&v_info);
	vorbis_comment_init(&v_comment);

	// page -> stream -> packet
	if(ogg_stream_pagein(&o_stream,&o_page) != 0) goto L_ERR;
	if(ogg_stream_packetout(&o_stream,&o_packet) <= 0) goto L_ERR;
	vorbis_synthesis_headerin(&v_info,&v_comment,&o_packet);

	// tH[}bg擾
	SetWaveFmt(&WaveFmt,(WORD)v_info.channels,(WORD)v_info.rate,16);

	//-----------------------------------------------------------------
	//  2 ̃pPbgRg擾 
	// Rgp̃pPbg͌\傫̂Őy[Wɓn邱Ƃ̂ɒ
	//-----------------------------------------------------------------
	i = 0;
	while(i<2){
		
		// sync -> page
		while(ogg_sync_pageout(&o_sync,&o_page) == 0)  WriteToSyncBuf(HdInputOggFile,&o_sync,dwReadByte);

		// page -> stream
		ogg_stream_pagein(&o_stream,&o_page);
		
		// stream -> packet
		while(ogg_stream_packetout(&o_stream,&o_packet)){
			
			vorbis_synthesis_headerin(&v_info,&v_comment,&o_packet);
			i++;
		}

	}

	//-----------------------------
	// PCM f[^ɃfR[h鏀
	//-----------------------------
	vorbis_synthesis_init(&v_dsp,&v_info); 
	vorbis_block_init(&v_dsp,&v_block);    

	// PCM ł̃TCY擾
	DwPCMsize 
		= GetOggPCMAbPos(HdInputOggFile,DwFileSize,LnSerial,&DwTotalPage,
		Buffer, 
		min(DwFileSize,64*1024+1024)  // 1 y[W̍ő 64k 
		) * WaveFmt.nBlockAlign;

	memset(pInfo,0,sizeof(OGGINPUTINFO));
	pInfo->samplingRate = v_info.rate;
	pInfo->channels = v_info.channels;
	pInfo->totalSec = (DWORD)((double)DwPCMsize*1000./WaveFmt.nAvgBytesPerSec);
	pInfo->bitRate = (DWORD)((double)DwFileSize*8./(pInfo->totalSec/1000.));

	ppszComment = v_comment.user_comments;
	while(*ppszComment){
		if(strnicmp(*ppszComment,"TITLE=",6)==0) strcpy(pInfo->szTrackName,(*ppszComment)+6);
		else if(strnicmp(*ppszComment,"ARTIST=",7)==0) strcpy(pInfo->szArtistName,(*ppszComment)+7);
		else if(strnicmp(*ppszComment,"ALBUM=",6)==0) strcpy(pInfo->szAlbumName,(*ppszComment)+6);
		else if(strnicmp(*ppszComment,"DATE=",5)==0) strcpy(pInfo->szData,(*ppszComment)+5);
		ppszComment++;
	}

#ifdef _DEBUG
	fprintf(f,"%s %s %s %s %d Hz, %d chn, %d kbps, %d sec, size = %u, %d pages\n",
		pInfo->szTrackName,
		pInfo->szArtistName,
		pInfo->szAlbumName,
		pInfo->szData,
		pInfo->samplingRate,
		pInfo->channels,
		pInfo->bitRate/1000,
		pInfo->totalSec/1000,
		DwPCMsize,
		DwTotalPage);
#endif

	DblSeekTime = 0;
	BlPause = FALSE;
	DwCurPos = 0;

	return TRUE;

L_ERR:

	if(LpMsgProc) LpMsgProc(0,0,0);

	oggdec_close();

	return FALSE;

}



//------------------------------------------------------------
// callback function
BOOL EXPORT oggdec_callback(OGGINPUT_MSG_PROC pProc){

	if(HdOggPlayThread) return FALSE; // Đ

	LpMsgProc = pProc;
	return TRUE;
}




//------------------------------------------------------------
// play pXbh
// y[WPʂōĐ
DWORD WINAPI oggdec_play_thread(LPVOID lpPlayData){

	float **pcmdata;
	LONG nSampleNum;
	DWORD i;
	DWORD dwCurSampleSize,dwReadbyte;
	DWORD dwMaxPCMsample;  // obt@̃Tv𒴂Đ(ŃR[obN̊Ԋu𒲐)
	BOOL bEOF;
	BOOL bResetWave;
	LARGE_INTEGER liPrePos;
	LARGE_INTEGER liGraPos; // ݂̃y[W̐擪̈ʒu
	LARGE_INTEGER liSeekPos;
	DWORD dwRet = 1;

	if(DwCallBackTime >= MAX_CALLBACK_TIME) DwCallBackTime = MAX_CALLBACK_TIME;
	dwMaxPCMsample = (DWORD)((double)DwCallBackTime/1000. * WaveFmt.nSamplesPerSec);

	// WAVE foCXI[v
	if(!OpenWaveDevice(DeviceID,WaveFmt,
		dwMaxPCMsample*WaveFmt.nBlockAlign*2 // ]T 2 {炢̃ƂƂ
		)) goto L_ERR;

	// [vJn
	DwThreadStat = ID_THREAD_SEEK;
	dwCurSampleSize = 0;
	liPrePos.QuadPart = 0;
	bEOF = FALSE;

	while(1){

		//--------------------
		// y[WPʂŃV[N
		//---------------------
		
		if(DwThreadStat == ID_THREAD_SEEK){
			
#ifdef _DEBUG
			fprintf(f,"\n[SEEK %lf sec]\n",DblSeekTime/1000);
#endif

			if(SeekOggPage(HdInputOggFile,DwFileSize,LnSerial,v_info.bitrate_nominal,DblSeekTime,WaveFmt,Buffer,BUFSIZE,&liSeekPos)){
				ResetWave();
				ogg_sync_reset(&o_sync); 
				ogg_stream_reset(&o_stream);
				DwThreadStat = ID_THREAD_ON;
				dwCurSampleSize = 0;
				liGraPos = liSeekPos;

#ifdef _DEBUG
			fprintf(f,"SEEK succeed page = %d\n",ogg_page_pageno(&o_page));
#endif

			}
			else goto L_ERR;
		}
		

		//---------------------
		// fR[h
		//---------------------

		// sync -> page
		while(ogg_sync_pageout(&o_sync,&o_page) == 0){
			dwReadbyte = WriteToSyncBuf(HdInputOggFile,&o_sync,BUFSIZE);
			if(!dwReadbyte) break;

			if(DwThreadStat != ID_THREAD_ON || BlPause) goto L_EXIT; // ً}Eo
		}

#ifdef _DEBUG
		fprintf(f,"\n[PAGE IN %d]\ndwReadByte = %u\n",ogg_page_pageno(&o_page),dwReadbyte);
#endif
		if(!dwReadbyte) break;

		// ĐʒuZbg
		// DwCurPos = y[W̓̈ʒu + foCXɑf[^
		liPrePos.QuadPart = ogg_page_granulepos(&o_page);
		DwCurPos = liGraPos.LowPart;
			
		// page -> stream
		if(ogg_stream_pagein(&o_stream,&o_page) == 0){
			
#ifdef _CHK_CLOCK
			LARGE_INTEGER liB,liA,liC;
			DWORD dwClock;
			
			dwClock = 0;
			liC.QuadPart = 0;
#endif			
			
			// stream -> packet
			while(ogg_stream_packetout(&o_stream,&o_packet)){
		
				if(DwThreadStat != ID_THREAD_ON || BlPause) goto L_EXIT; // ً}Eo
				
				// V[N͍ŏ̃pPbĝĂȂƃmCY
				if(DblSeekTime != 0) DblSeekTime = 0; 
				else
				{
					
					if(vorbis_synthesis(&v_block,&o_packet)==0)  
						vorbis_synthesis_blockin(&v_dsp,&v_block);
					
					while((nSampleNum = vorbis_synthesis_pcmout(&v_dsp,&pcmdata)) > 0)
					{
						
						if(DwThreadStat != ID_THREAD_ON || BlPause) goto L_EXIT; // ً}Eo
						
						// pcmdata -> FtPCMbufer
						for(i=0; i< WaveFmt.nChannels; i++)
							memcpy(FtPCMbufer[i]+dwCurSampleSize,pcmdata[i],nSampleNum*sizeof(double));
						dwCurSampleSize += nSampleNum;
						
						vorbis_synthesis_read(&v_dsp,nSampleNum); 
						
						if(dwCurSampleSize > dwMaxPCMsample)
						{
							
#ifdef _DEBUG
							fprintf(f,"samplesize = %d\n",dwCurSampleSize);
#endif
							
							// double -> short ϊ
							for(i=0; i< WaveFmt.nChannels; i++){
								
#ifdef _CHK_CLOCK
								GetCurCycle(&liB);
#endif
								// FtPCMbufer -> PCMbuffer 
								ConvFloat2Short(
									FtPCMbufer[i],
									PCMbuffer,
									FtVol,
									dwCurSampleSize,i,WaveFmt.nChannels,dwSSE);
#ifdef _CHK_CLOCK
								GetCurCycle(&liA);
								liC.QuadPart = liA.QuadPart-liB.QuadPart;
								dwClock++;
								
#endif	
							}
							
							
							// TEhfoCXɃf[^𑗂
							if(PlayWave((LPBYTE)PCMbuffer,dwCurSampleSize*WaveFmt.nBlockAlign,&DwThreadStat,&BlPause)){
								memcpy(GetWaveBuffer,PCMbuffer,dwCurSampleSize*WaveFmt.nBlockAlign);

								DwGetWaveBufSample = dwCurSampleSize;
								DwCurPos += dwCurSampleSize;
								dwCurSampleSize = 0;

								// R[obN֐Ă
								if(LpMsgProc) LpMsgProc(2,
									(DWORD)((double)DwCurPos*1000./WaveFmt.nSamplesPerSec)
									,0); 
#ifdef _DEBUG
							fprintf(f,"callback pos = %d %d\n",DwCurPos,(DWORD)((double)DwCurPos*1000./WaveFmt.nSamplesPerSec));
#endif
							}

						}
						
					}
				}
				
			}
			
#ifdef _CHK_CLOCK
			if(dwClock) 
				fprintf(f,"\nclk = %lu (%d)",liC.LowPart/dwClock,dwClock);
#endif

		
		}

		liGraPos.QuadPart = liPrePos.QuadPart;
			
		// EOS Ȃ烋[vEo
		if(ogg_page_eos(&o_page)) {
				bEOF = TRUE;
#ifdef _DEBUG
				fprintf(f,"EOF\n");
#endif
		}

		
L_EXIT:
		
		// |[Y
		bResetWave = TRUE;
		while(BlPause){
			
			// Ăяo WAVE foCXZbg
			if(bResetWave){
				ResetWave();
				bResetWave = FALSE;

				DwThreadStat = ID_THREAD_SEEK;
				DblSeekTime = (double)liGraPos.QuadPart/WaveFmt.nSamplesPerSec*1000-DwCallBackTime;

				// bZ[WM
				if(LpMsgProc) LpMsgProc(3,0,0); 
			}

			if(DwThreadStat == ID_THREAD_OFF) break;
			Sleep(10);
		}
		
		if(DwThreadStat == ID_THREAD_OFF) break;
		if(bEOF) break;
	}

	// EOF ȂcĐ
	if(bEOF && dwCurSampleSize){
		PlayWave((LPBYTE)PCMbuffer,dwCurSampleSize*WaveFmt.nBlockAlign,&DwThreadStat,&BlPause); 
		if(LpMsgProc) LpMsgProc(2,(DWORD)((double)DwPCMsize*1000./WaveFmt.nAvgBytesPerSec),0); 
	}

	dwRet = 0;

L_ERR:

	if(LpMsgProc && dwRet != 0) LpMsgProc(0,0,0);

	CloseWaveDevice((DwThreadStat == ID_THREAD_OFF));

	DwThreadStat = ID_THREAD_OFF;
	HdOggPlayThread = NULL;

	if(LpMsgProc) LpMsgProc(4,0,0); // ĐI

#ifdef _DEBUG
	fprintf(f,"\n[XbhI]\n");
#endif

	return dwRet;
}




//------------------------------------
// play 
BOOL EXPORT oggdec_play(){

	DWORD dwThreadId;
	
	// Đ
	if(HdOggPlayThread){
		BlPause = FALSE;  // |[Y
		return TRUE; 
	}

	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;

	memset(GetWaveBuffer,0,sizeof(short)*256*2);
	DwGetWaveBufSample = 0;
	HdOggPlayThread = CreateThread(NULL,0,
		(LPTHREAD_START_ROUTINE)oggdec_play_thread,
		(LPVOID)NULL,
		0,(LPDWORD)&dwThreadId);

	ReleaseSemaphore(HsempLock,1,NULL);

	return TRUE;
}





//---------------------------------------
// seek
BOOL EXPORT oggdec_seek(DWORD dwMsec){

	DWORD i;
	BOOL bRet = TRUE;
	
	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;

	DblSeekTime = (double)dwMsec;
	
	// Xbh쒆̏ꍇ
	if(DwThreadStat == ID_THREAD_ON){

		DwThreadStat = ID_THREAD_SEEK;
		i=0;
		while(DwThreadStat == ID_THREAD_SEEK && i<50){
			Sleep(50);
			i++;
		}
		if(i >= 50) bRet = FALSE;
	}

	ReleaseSemaphore(HsempLock,1,NULL);

	return bRet;
}


//---------------------------------------
// pause
BOOL EXPORT oggdec_pause(){

	// Đ
	if(HdOggPlayThread) BlPause = TRUE;  

	return TRUE;
}



//---------------------------------------
// restart
BOOL EXPORT oggdec_restart(){

	return(oggdec_play());
}



//---------------------------------------------------
// get wave 
DWORD EXPORT oggdec_getWave(short* pWaveL, short* pWaveR, DWORD dwMaxSize){

	DWORD i,i2;
	DWORD dwSetPoint;
	short* pOut[2];

	pOut[0] = pWaveL;
	pOut[1] = pWaveR;
	dwSetPoint = min(dwMaxSize,DwGetWaveBufSample);

	memset(pOut[1],0,sizeof(short)*dwMaxSize);
	for(i=0;i<WaveFmt.nChannels;i++){

		for(i2=0;i2<dwSetPoint;i2++){
			pOut[i][i2] = GetWaveBuffer[i+i2*WaveFmt.nChannels];
		}

	}

	return dwSetPoint;
}



//------------------------------------
// set waveout device
void EXPORT oggdec_setWaveOutDeviceId(unsigned int uId){

	DeviceID = uId;
}




//--------------------------------------------
// version
long EXPORT oggdec_getVersion(char* lpszVer){

	long nRet = 0;

	if(lpszVer) strcpy(lpszVer,VER_STR);
	nRet = (long)(VER_NUM*100.);

#ifdef _DEBUG
	fprintf(f,"[version] %d %s\n",nRet,lpszVer);
#endif

	return nRet;
}


//--------------------------------------------
// state
DWORD EXPORT oggdec_getState(LPDWORD lpdwMsec){

	*lpdwMsec = 0;

	if(!HdOggPlayThread) return 0;

	*lpdwMsec = 
		(DWORD)((double)DwCurPos*1000./WaveFmt.nSamplesPerSec); 

	if(BlPause) return 2;


	return 1;
}


// EOF