// oggdec.dll sample   2002/4/11
// LICENSE : FREE.

#include <windows.h>
#include <stdio.h>
#include "oggdec.h"


// call back function
VOID CALLBACK  MyOggCallbackProc(DWORD id,DWORD param,DWORD param2)
{
	short pWaveL[1024];
	short pWaveR[1024];
	
	switch (id) {

	case 0: // error

		fprintf(stderr,"\ncallback: error.\n");
		break;

	case 2: // play
		
		oggdec_getWave(pWaveL,pWaveR,1024);  
		fprintf(stderr,"\015%4d s  %6d %6d",param/1000 // msec -> sec
			,pWaveL[0],pWaveR[1]);
		break;

	case 3: //pause
		fprintf(stderr,"\ncallback: pause.\n");
		break;

	case 4:  // close

		fprintf(stderr,"\ncallback: wave device closed.\n");
		break;
		
	default:
        break;
    }
}



// main
int main(int argc, char* argv[]){
	
	OGGINPUTINFO inInfo;
	char szVer[256];
	char szFile[256];
	char szCommand[256];
	long nSeekTime,nVer;
	
	if(argc == 1){
		fprintf(stderr,"playsample input.ogg\n");
		exit(0);
	}

	strcpy(szFile,argv[1]);
	
	if(!oggdec_init()){
		fprintf(stderr,"err: oggdec_init\n");
		exit(1);
	}

	if(!oggdec_callback(MyOggCallbackProc)){
		fprintf(stderr,"err: oggdec_callback\n");
		exit(1);
	}

	if(!oggdec_open(szFile,&inInfo)){
		fprintf(stderr,"err: oggdec_open\n");
		exit(1);
	}

	nVer = oggdec_getVersion(szVer);
	
	fprintf(stderr,"%s (%d)\n%s %s %s %d Hz, %d chn, %d kbps, %d sec\n",
		szVer,
		nVer,
		szFile,
		inInfo.szTrackName,
		inInfo.szArtistName,
		inInfo.samplingRate,
		inInfo.channels,
		inInfo.bitRate/1000,
		inInfo.totalSec);
	
	oggdec_setWaveOutDeviceId(WAVE_MAPPER); 
	oggdec_seek(0);	

	if(!oggdec_play()){
		fprintf(stderr,"err: oggdec_play\n");
		exit(1);
	}
	
	while(1){
		
		fscanf(stdin,"%s",szCommand);
		
		if(szCommand[0] == 'q') break; // quit
		
		else if(szCommand[0] == 'p'){ // play
			fprintf(stderr,"play\n");
			oggdec_play();
		}
		
		else if(szCommand[0] == 'x'){ // pause
			fprintf(stderr,"pause\n");
			oggdec_pause();
		}

		else if(szCommand[0] == 'r'){ // restart
			fprintf(stderr,"restart\n");
			oggdec_restart();
		}

		else if(szCommand[0] == 's'){ // stop
			fprintf(stderr,"stop\n");
			oggdec_stop();
		}

		else if(szCommand[0] == 'i'){ // state
			DWORD dwState,dwTime;
			dwState = oggdec_getState(&dwTime);
			fprintf(stderr,"state = %d,  %u msec\n",dwState,dwTime);
		}
		
		else{ // seek
			nSeekTime = atoi(szCommand);
			oggdec_seek(nSeekTime*1000); // sec -> msec
			fprintf(stderr,"\nmove to %d sec\n",nSeekTime);
		}
	}
	
	if(!oggdec_close()){
		fprintf(stderr,"err: oggdec_close\n");
		exit(1);
	}
	
	
	if(!oggdec_free()){
		fprintf(stderr,"err: oggdec_free\n");
		exit(1);
	}
	
	fprintf(stderr,"\ndone.\n");
	
	return 0;
}
